(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('ngx-array', ['exports', '@angular/core'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["ngx-array"] = {}, global.ng.core));
})(this, (function (exports, i0) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var NgxArrayService = /** @class */ (function () {
        function NgxArrayService() {
        }
        /**
         * _min: Returns the minimum value in the array
         * @param arr: Array of values of any type[].
         */
        NgxArrayService.prototype._min = function (arr) {
            try {
                if (!Array.isArray(arr)) {
                    throw new Error("_min - Invalid Arguments: Array / Item should be valid");
                }
                return Math.min.apply(null, arr);
            }
            catch (error) {
                console.trace(error);
            }
        };
        /**
         * _max: Returns the maximum value in the array
         * @param arr: Array of values of any type[].
         */
        NgxArrayService.prototype._max = function (arr) {
            try {
                if (!Array.isArray(arr)) {
                    throw new Error("_max - Invalid Arguments: Array / Item should be valid");
                }
                return Math.max.apply(null, arr);
            }
            catch (error) {
                console.trace(error);
            }
        };
        /**
         * _sortNumbers: method sorts the elements of an numbers array in place and returns the sorted array. The default sort order is ascending
         ** Use only array of numbers (or) strings for better result
         * @param arr: Array of values of any type[].
         * @param mode: 1 for ascending , -1 for descending - Default 1
         */
        NgxArrayService.prototype._sortNumbers = function (arr, mode) {
            if (mode === void 0) { mode = 1; }
            try {
                if (!Array.isArray(arr)) {
                    throw new Error("_sortNumbers - Invalid Arguments: Array / Item should be valid");
                }
                return mode === 1 ? arr.sort(function (a, b) { return a - b; }) : arr.sort(function (a, b) { return b - a; });
            }
            catch (error) {
                console.trace(error);
            }
        };
        /**
         * _sort: method sorts the elements of an array in place and returns the sorted array. The default sort order is ascending
         ** Use only array of numbers (or) strings for better result
         * @param arr: Array of values of any type[].
         */
        NgxArrayService.prototype._sort = function (arr) {
            try {
                if (!Array.isArray(arr)) {
                    throw new Error("_sort - Invalid Arguments: Array / Item should be valid");
                }
                return arr.sort();
            }
            catch (error) {
                console.trace(error);
            }
        };
        /**
         * _reverse: Returns the reverse ordered array
         * @param arr: Array of values of any type[].
         */
        NgxArrayService.prototype._reverse = function (arr) {
            try {
                if (!Array.isArray(arr)) {
                    throw new Error("_reverse - Invalid Arguments: Array / Item should be valid");
                }
                return arr.reverse();
            }
            catch (error) {
                console.trace(error);
            }
        };
        /**
         * _join: New string by concatenating all of the elements in an array
         * @param arr: Array of values of any type[].
         * @param joinBy: Concatenate by the string example = (-). Default is ''
         */
        NgxArrayService.prototype._join = function (arr, joinBy) {
            if (joinBy === void 0) { joinBy = ""; }
            try {
                if (!Array.isArray(arr)) {
                    throw new Error("_join - Invalid Arguments: Array / Item should be valid");
                }
                return arr.join(joinBy);
            }
            catch (error) {
                console.trace(error);
            }
        };
        /**
         * _isValidArray: Checks whether the passed item is array or not
         * * return true if valid
         * * return false if not valid
         * @param arr: Array of values of any type[].
         */
        NgxArrayService.prototype._isValidArray = function (arr) {
            try {
                return Array.isArray(arr);
            }
            catch (error) {
                console.trace(error);
            }
        };
        /**
         * _indexOfFrom: Returns the index of item from given array from starting at particular index
         * * return index of exists
         * * return -1 if not exists
         * @param arr: Array of values of any type[].
         * @param item: Searchable item in array of any type
         * @param start: Starting index
         */
        NgxArrayService.prototype._indexOfFrom = function (arr, item, start) {
            try {
                if (!item || !Array.isArray(arr)) {
                    throw new Error("_indexOfFrom - Invalid Arguments: Array / Item should be valid");
                }
                return arr.indexOf(item, start);
            }
            catch (error) {
                console.trace(error);
            }
        };
        /**
         * _indexOf: Returns the index of item from given array
         * * return index of exists
         * * return -1 if not exists
         * @param arr: Array of values of any type[].
         * @param item: Searchable item in array of any type
         */
        NgxArrayService.prototype._indexOf = function (arr, item) {
            try {
                if (!item || !Array.isArray(arr)) {
                    throw new Error("_indexOf - Invalid Arguments: Array / Item should be valid");
                }
                return arr.indexOf(item);
            }
            catch (error) {
                console.trace(error);
            }
        };
        /**
         * _hasAt: Checks whether the array contains the item at particular given index
         * * return true if exists
         * * return false if not exists
         * @param arr: Array of values of any type[].
         * @param item: Searchable item in array of any type
         * @param positionIndex: Starting index
         */
        NgxArrayService.prototype._hasAt = function (arr, item, positionIndex) {
            try {
                if (!item || !Array.isArray(arr)) {
                    throw new Error("_hasAt - Invalid Arguments: Array / Item should be valid");
                }
                return arr.includes(item, positionIndex);
            }
            catch (error) {
                console.trace(error);
            }
        };
        /**
         * _has: Checks whether the array contains the item
         * * return true if exists
         * * return false if not exists
         * @param arr: Array of values of any type[].
         * @param item: Searchable item in array of any type
         */
        NgxArrayService.prototype._has = function (arr, item) {
            try {
                if (!item || !Array.isArray(arr)) {
                    throw new Error("_has - Invalid Arguments: Array / Item should be valid");
                }
                return arr.includes(item);
            }
            catch (error) {
                console.trace(error);
            }
        };
        /**
         * _filterNumbersArray: Filters integer array for an given condition and returns a new array.
         * * return filtered new array
         * @param arr: Array of values of any type [].
         * @param condition: Possible conditions  ('>' , '<' , '>=', '<=' , '!==')
         * @param expected: Resulted value should be in
         */
        NgxArrayService.prototype._filterNumbersArray = function (arr, condition, expected) {
            try {
                if (!Array.isArray(arr)) {
                    throw new Error("_filterNumbersArray - Invalid Arguments: Invalid length of Array");
                }
                switch (condition) {
                    case ">":
                        return arr.filter(function (value) { return value > expected; });
                    case "<":
                        return arr.filter(function (value) { return value < expected; });
                    case "<=":
                        return arr.filter(function (value) { return value <= expected; });
                    case ">=":
                        return arr.filter(function (value) { return value >= expected; });
                    case "!=":
                        return arr.filter(function (value) { return value !== expected; });
                    default:
                        throw new Error("Invalid condition: Invalid type of condition passed use ('>' , '<' , '>=', '<=' , '!==' )");
                }
            }
            catch (error) {
                console.trace(error);
            }
        };
        /**
         * _fill: method shallow copies part of an array to another location in the same array and returns it without modifying its length method changes all elements in an array to a static value, from a start index (default 0) to an end index (default array.length). It returns the modified array.
         * * Returns new array
         * @param arr: Array of values of any type [].
         * @param value: value to be filled in array
         * @param from: Start from this position
         * @param to: End at this position
         */
        NgxArrayService.prototype._fill = function (arr, value, from, to) {
            try {
                if (!from || !Array.isArray(arr)) {
                    throw new Error("_fill - Invalid Arguments: Array / Item should be valid");
                }
                else if (from > arr.length - 1 || to > arr.length - 1) {
                    throw new Error("_fill - Invalid index: Start / End index out of range");
                }
                return arr.fill(value, from, to);
            }
            catch (error) {
                console.trace(error);
            }
        };
        /**
         * _copyWithin: method shallow copies part of an array to another location in the same array and returns it without modifying its length
         * return new array
         * @param arr: Array of values of any type [].
         * @param from: Start from this position
         * @param to: End at this position
      
         */
        NgxArrayService.prototype._copyWithin = function (arr, from, to) {
            try {
                if (!from || !Array.isArray(arr)) {
                    throw new Error("_copyWithin - Invalid Arguments: Array / Item should be valid");
                }
                else if (from > arr.length - 1 || to > arr.length - 1) {
                    throw new Error("_copyWithin - Invalid index: Start / End index out of range");
                }
                return arr.copyWithin(from, to);
            }
            catch (error) {
                console.trace(error);
            }
        };
        /**
         * _concat: method is used to merge two or more arrays.
         * This method does not change the existing arrays, but instead returns a new array.
         * * return new concatenated array
         * @param args: Multiple Array of values at any length .
         */
        NgxArrayService.prototype._concat = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            try {
                var concatArray_1 = [];
                args.forEach(function (element) {
                    var e_1, _a;
                    if (element.length === -1) {
                        throw new Error("_concat - Invalid Arguments: Invalid Array");
                    }
                    else {
                        try {
                            for (var element_1 = __values(element), element_1_1 = element_1.next(); !element_1_1.done; element_1_1 = element_1.next()) {
                                var iterator = element_1_1.value;
                                concatArray_1.push(iterator);
                            }
                        }
                        catch (e_1_1) { e_1 = { error: e_1_1 }; }
                        finally {
                            try {
                                if (element_1_1 && !element_1_1.done && (_a = element_1.return)) _a.call(element_1);
                            }
                            finally { if (e_1) throw e_1.error; }
                        }
                    }
                });
                return concatArray_1;
            }
            catch (error) {
                console.trace(error);
            }
        };
        /**
         * _length: Returns the length of the given array
         * * return length of the array
         * @param arr: Array of values of any type [].
         */
        NgxArrayService.prototype._length = function (arr) {
            try {
                if (!Array.isArray(arr)) {
                    throw new Error("_length - Invalid Arguments: Invalid length of Array");
                }
                return arr.length || 0;
            }
            catch (error) {
                console.trace(error);
            }
        };
        /**
         * _copy: Duplicates an array
         * * returns same array as result
         * @param arr: Array of values of any type [].
         */
        NgxArrayService.prototype._copy = function (arr) {
            return __spreadArray([], __read(arr));
        };
        /**
         * _slice: returns a shallow copy of a portion of an array into a new array object selected from start to end
         * * return removed array
         * @param arr: Array of values of any type [].
         * @param start: Start from this position
         * @param end: End at this position , Default is length of the array
         */
        NgxArrayService.prototype._slice = function (arr, start, end) {
            if (end === void 0) { end = arr.length - 1; }
            try {
                if (!start || !Array.isArray(arr)) {
                    throw new Error("_slice - Invalid Arguments: Array / Item should be valid");
                }
                else if (start > arr.length - 1 || end > arr.length - 1) {
                    throw new Error("_slice - Invalid index: Start / End index out of range");
                }
                return arr.slice(start, end);
            }
            catch (error) {
                console.trace(error);
            }
        };
        /**
         * _splice: Cut of / Splice of an items at particular valid index
         * * return removed array
         * @param arr: Array of values of any type [].
         * @param start: Start from this position
         * @param end: End at this position , Default is 1
         */
        NgxArrayService.prototype._splice = function (arr, start, end) {
            if (end === void 0) { end = 1; }
            try {
                if (!start || !Array.isArray(arr)) {
                    throw new Error("_splice - Invalid Arguments: Array / Item should be valid");
                }
                else if (start > arr.length - 1 || end > arr.length - 1) {
                    throw new Error("_splice - Invalid index: Start / End index out of range");
                }
                return arr.splice(start, end);
            }
            catch (error) {
                console.trace(error);
            }
        };
        /**
         *  _shift: It will remove the array item at beginning & return item
         * * return the item if removed from array at beginning
         * @param arr: Array of values of any type [].
         */
        NgxArrayService.prototype._shift = function (arr) {
            try {
                if (!Array.isArray(arr)) {
                    throw new Error("_shift - Invalid Arguments: Array should be valid");
                }
                return arr.shift();
            }
            catch (error) {
                console.trace(error);
            }
        };
        /**
         *  _shift: method adds one or more elements to the beginning of an array and returns the new length of the array.
         ** Use spread operator while passing array [...arr]
         * @param arr: Array of values of any type []. use spread operator [...arr]
         * @param args: Any length of values seperated by comma to unshift in array example _unshift(array,1,2,3,4,5...)
         */
        NgxArrayService.prototype._unshift = function (arr) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            try {
                if (!Array.isArray(arr)) {
                    throw new Error("_unshift - Invalid Arguments: Array should be valid");
                }
                arr.unshift(args);
                return arr.reduce(function (acc, val) { return acc.concat(val); }, []);
            }
            catch (error) {
                console.trace(error);
            }
        };
        /**
         * _pop: It will remove the array item at end & return item
         * * return the item if removed from array at end
         * @param arr: Array of values of any type [].
         */
        NgxArrayService.prototype._pop = function (arr) {
            try {
                if (!Array.isArray(arr)) {
                    throw new Error("_pop - Invalid Arguments: Array should be valid");
                }
                return arr.pop();
            }
            catch (error) {
                console.trace(error);
            }
        };
        /**
         * _push: It will add / push new item to the array at end & return new array
         * * return the new array.
         * @param arr: Array of values of any type [].
         * @param item: item to be pushed of any type
         */
        NgxArrayService.prototype._push = function (arr, item) {
            try {
                if (!item) {
                    throw new Error("_push - Invalid Arguments: Item should be valid");
                }
                return __spreadArray(__spreadArray([], __read(arr)), [item]);
            }
            catch (error) {
                console.trace(error);
            }
        };
        return NgxArrayService;
    }());
    NgxArrayService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.9", ngImport: i0__namespace, type: NgxArrayService, deps: [], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    NgxArrayService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.9", ngImport: i0__namespace, type: NgxArrayService, providedIn: 'root' });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.9", ngImport: i0__namespace, type: NgxArrayService, decorators: [{
                type: i0.Injectable,
                args: [{
                        providedIn: 'root'
                    }]
            }], ctorParameters: function () { return []; } });

    var NgxArrayComponent = /** @class */ (function () {
        function NgxArrayComponent() {
        }
        NgxArrayComponent.prototype.ngOnInit = function () {
        };
        return NgxArrayComponent;
    }());
    NgxArrayComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.9", ngImport: i0__namespace, type: NgxArrayComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    NgxArrayComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.9", type: NgxArrayComponent, selector: "lib-ngx-array", ngImport: i0__namespace, template: "\n    <p>\n      ngx-array works!\n    </p>\n  ", isInline: true });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.9", ngImport: i0__namespace, type: NgxArrayComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'lib-ngx-array',
                        template: "\n    <p>\n      ngx-array works!\n    </p>\n  ",
                        styles: []
                    }]
            }], ctorParameters: function () { return []; } });

    var NgxArrayModule = /** @class */ (function () {
        function NgxArrayModule() {
        }
        return NgxArrayModule;
    }());
    NgxArrayModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.9", ngImport: i0__namespace, type: NgxArrayModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    NgxArrayModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.9", ngImport: i0__namespace, type: NgxArrayModule, declarations: [NgxArrayComponent], exports: [NgxArrayComponent] });
    NgxArrayModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.9", ngImport: i0__namespace, type: NgxArrayModule, imports: [[]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.9", ngImport: i0__namespace, type: NgxArrayModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            NgxArrayComponent
                        ],
                        imports: [],
                        exports: [
                            NgxArrayComponent
                        ]
                    }]
            }] });

    /*
     * Public API Surface of ngx-array
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NgxArrayComponent = NgxArrayComponent;
    exports.NgxArrayModule = NgxArrayModule;
    exports.NgxArrayService = NgxArrayService;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-array.umd.js.map
